# Order To Shipment

This endpoint is used to process the orders downloaded from marketplace or e-commerce by Gsped

The call to this endpoint generates the shipment using the address of the order recipient.

## Shipment creation from an order

<mark style="color:green;">`POST`</mark> `https://api.gsped.it/[INSTANCE]/OrderToShipment`

Generates a shipment from an order to process it and update the ecommerce/marketplace

#### Headers

| Name                                        | Type   | Description           |
| ------------------------------------------- | ------ | --------------------- |
| x-api-key<mark style="color:red;">\*</mark> | String | APIKEY given by Gsped |

#### Request Body

| Name                                         | Type   | Description                                                                 |
| -------------------------------------------- | ------ | --------------------------------------------------------------------------- |
| client\_id<mark style="color:red;">\*</mark> | Int    | Client ID Gsped                                                             |
| order\_ref<mark style="color:red;">\*</mark> | String | Order reference                                                             |
| packages<mark style="color:red;">\*</mark>   | Int    | Number of parcels                                                           |
| weight<mark style="color:red;">\*</mark>     | Float  | Weight of the order                                                         |
| platform                                     | String | Name of the platform that created the order                                 |
| labelType                                    | Enum   | <p>Possible values are: PDF/ZPL<br>Some couriers may have restrinctions</p> |

{% tabs %}
{% tab title="200: OK Generated shipment response" %}

```json
{
  "status": "OK",
  "order_ref": "FC3926207",
  "label_jpg": [
    "base64 label string"
  ],
  "label_pdf": [
    "base64 label string"
  ],
  "label_zpl": [
    "ZPL label string"
  ]
}
```

{% endtab %}

{% tab title="400: Bad Request Response order not found" %}

```json
{
  "status": "ERROR",
  "error_description": "Ordine non trovato",
  "order_ref": "WrongRif"
}
```

{% endtab %}

{% tab title="400: Bad Request Response wrong Payload" %}

```json
{
  "status": "ERROR",
  "error_description": "Dati ordine non presenti o in formato sbagliato",
  "order_ref": ""
}
```

{% endtab %}

{% tab title="403: Forbidden Invalid Apikey" %}

```json
{
  "status": false,
  "error": "Invalid API key "
}
```

{% endtab %}

{% tab title="500: Internal Server Error Generic errors" %}

```json
```

{% endtab %}
{% endtabs %}

#### Example Snippets

{% tabs %}
{% tab title="PHP" %}

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.gsped.it/sandbox/OrderToShipment",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => "{\n\t\"client_id\": 1,\n\t\"order_ref\": \"14326\",\n\t\"packages\": 2,\n\t\"platform\": \"woocommerce\",\n\t\"weight\": 7.09\n}",
  CURLOPT_HTTPHEADER => [
    "Content-Type: application/json",
    "x-api-key: YOUR-API-KEY"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

{% endtab %}

{% tab title="PYTHON" %}

```python
import http.client

conn = http.client.HTTPSConnection("api.gsped.it")

payload = "{\n\t\"client_id\": 1,\n\t\"order_ref\": \"14326\",\n\t\"packages\": 2,\n\t\"platform\": \"woocommerce\",\n\t\"weight\": 7.09\n}"

headers = {
    'Content-Type': "application/json",
    'x-api-key': "YOUR-API-KEY"
    }

conn.request("POST", "/sandbox/OrderToShipment", payload, headers)

res = conn.getresponse()
data = res.read()

print(data.decode("utf-8"))
```

{% endtab %}

{% tab title="GO" %}

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io/ioutil"
)

func main() {

	url := "https://api.gsped.it/sandbox/OrderToShipment"

	payload := strings.NewReader("{\n\t\"client_id\": 1,\n\t\"order_ref\": \"14326\",\n\t\"packages\": 2,\n\t\"platform\": \"woocommerce\",\n\t\"weight\": 7.09\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")
	req.Header.Add("x-api-key", "YOUR-API-KEY")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := ioutil.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

{% endtab %}

{% tab title="C#" %}

```csharp
var client = new HttpClient();
var request = new HttpRequestMessage
{
    Method = HttpMethod.Post,
    RequestUri = new Uri("https://api.gsped.it/sandbox/OrderToShipment"),
    Headers =
    {
        { "x-api-key", "YOUR-API-KEY" },
    },
    Content = new StringContent("{\n\t\"client_id\": 1,\n\t\"order_ref\": \"14326\",\n\t\"packages\": 2,\n\t\"platform\": \"woocommerce\",\n\t\"weight\": 7.09\n}")
    {
        Headers =
        {
            ContentType = new MediaTypeHeaderValue("application/json")
        }
    }
};
using (var response = await client.SendAsync(request))
{
    response.EnsureSuccessStatusCode();
    var body = await response.Content.ReadAsStringAsync();
    Console.WriteLine(body);
}
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --request POST \
  --url https://api.gsped.it/sandbox/OrderToShipment \
  --header 'Content-Type: application/json' \
  --header 'x-api-key: YOUR-API-KEY' \
  --data '{
	"client_id": 1,
	"order_ref": "14326",
	"packages": 2,
	"platform": "woocommerce",
	"weight": 7.09
}'
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://apidocs.gsped.com/gsped-api-english-version/gestione-ordini/order-to-shipment.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
